<template>
  <form @submit.prevent="submitForm" method="post">
    <el-dialog
      title="เพิ่มด้าน"
      v-model="openDialog"
      width="350px"
      :before-close="handleClose"
    >
      <div class="grid">
        <p>ปีงบประมาณ</p>
        <input
          :class="`${errors.name ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          :value="year.year"
          disabled
          placeholder="ปีงบประมาณ"
        />
        <small class="text-red-500 font-bold">{{ errors?.name }} </small>
      </div>
      <div class="grid">
        <p>ยุทธศาสตร์</p>
        <input
          :class="`${errors.name ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          :value="stargic.name"
          disabled
          placeholder="ยุทธศาสตร์"
        />
        <small class="text-red-500 font-bold">{{ errors?.name }} </small>
      </div>
      <div class="grid">
        <p>โครงการหลัก</p>
        <input
          :class="`${errors.name ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          :value="main.name"
          disabled
          placeholder="โครงการหลัก"
        />
        <small class="text-red-500 font-bold">{{ errors?.name }} </small>
      </div>
      <div class="grid">
        <p>ด้าน</p>
        <input
          :class="`${errors.name ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          v-model="form.name"
          placeholder="ด้าน"
        />
        <small class="text-red-500 font-bold">{{ errors?.name }} </small>
      </div>
      <template #footer>
        <span class="dialog-footer">
          <button
            @click="handleClose"
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-red-600
              to-red-400
              rounded-md
              text-white
              shadow-md
              mr-2
              focus:outline-none
            "
            type="button"
          >
            ยกเลิก
          </button>
          <button
            type="submit"
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-blue-600
              to-green-400
              rounded-md
              text-white
              shadow-md
              focus:outline-none
            "
          >
            เพิ่ม
          </button>
        </span>
      </template>
    </el-dialog>
  </form>
</template>

<script>
import { Inertia } from "@inertiajs/inertia";
import { defineComponent, reactive, ref, toRefs, watch } from "vue";

export default defineComponent({
  props: {
    open: {
      type: Boolean,
      required: true,
    },
    main: Object,
    stargic: Object,
    year: Object,
  },
  setup(props, { emit }) {
    //   model
    const { open, main, stargic, year } = toRefs(props);
    const openDialog = ref(false);
    watch(open, (value, prevValue) => {
      openDialog.value = value;
      console.log(main.value);
    });
    // form

    const form = reactive({
      name: null,
      stargic_id: stargic?.value?.id,
      budget_year_id: year?.value?.id,
      main_project_id: main?.value?.id,
    });
    const errors = reactive({
      name: null,
      stargic_id: stargic?.value?.id,
      budget_year_id: year?.value?.id,
      parent_id: main?.value?.id,

    });
    const submitForm = () => {
      Inertia.post(route("admin.projects.store", { type: "side" }), form, {
        onError: (err) => (errors.name = err.name),
        onSuccess: () => handleClose(),
      });
    };

    const handleClose = () => {
      emit("close");
      openDialog.value = false;
      form.name = null;
      errors.name = null;
    };
    return {
      stargic,
      year,
      openDialog,
      handleClose,
      submitForm,
      form,
      errors,
    };
  },
});
</script>
